<?php
    require GIFTMACHINE_DIR.'/lib/autoresponders/autoresponders.php';

function giftmachine_screen_autoresponders() {
    if (! current_user_can ( 'manage_options' ))
        wp_die ( 'You don\'t have access to this page.' );
    if (! user_can_access_admin_page ())
        wp_die ( __ ( 'You do not have sufficient permissions to access this page', 'wp-money-machine' ) );
        ?>
    <div class="wrap">
        <h1>Autoresponders</h1>
        <?php giftmachine_admin_autoresponders(); ?>
        <br/>
    </div>
        <?php
}

function giftmachine_admin_autoresponders( ) {
    giftmachine_check_authorize_ar_api();
    $settings = giftmachine_get_plugin_settings();
    // var_dump($settings);
    $ar_data = isset( $settings['autoresponders'] ) ? $settings['autoresponders'] : false;
    if( isset( $_POST['giftm_autoresponder_update'] ) ) {
        echo '<div class="notice notice-success notice-inline is-dismissible">
        <p><i class="fas fa-check"></i> Data Saved</p>
    </div>';
    }
?>

<div id="giftmachine-tabs" >
    <h2 class="nav-tab-wrapper">
        <a href="#aweber-tab" class="nav-tab nav-tab-active">Aweber</a>
        <a href="#getresponse-tab" class="nav-tab" >Getresponse</a>
        <a href="#icontact-tab" class="nav-tab">Icontact</a>
        <a href="#mailchimp-tab" class="nav-tab">Mailchimp</a>
        <a href="#ccontact-tab" class="nav-tab">Constant Contact</a>
        <a href="#sendreach-tab" class="nav-tab">Sendreach</a>
        <a href="#activecampaign-tab" class="nav-tab">Active Campaign</a>
        <a href="#sendlane-tab" class="nav-tab">Sendlane</a>
        <a href="#mailit-tab" class="nav-tab">Mailit Plugin</a>
        <a href="#mymailit-tab" class="nav-tab">MyMailit</a>
    </h2>

            <div style="clear:both"></div>
            <div id="mailit-tab" class="tab-inner" style="padding: 20px">

                            <h2><img src="<?php echo GIFTMACHINE_URL;?>/img/icons/icon_mailit.png" style="vertical-align: top" /> Mailit Plugin   - <a href="https://wpautocontent.com/support/mailit" target="_blank" style="font-size: 0.9em">Get it here</a></h2>
                            <form action="" method="post" class="form-horizontal" id="mailit-vp-form">
                                <input type="hidden" name="giftm_autoresponder_update" value="1" />
                            <?php
                                $mailit_type = isset( $plugin_options['autoresponders']['mailit']['install_type'] ) ? $plugin_options['autoresponders']['mailit']['install_type'] : 1;
                            ?>

                            <table class="form-table">
                                <tr valign="top">
                                    <th scope="row">Install Type</th>
                                    <td>
                                        <select name="giftmachine_mailit_type" id="giftmachine_mailit_type"  class="form-control">
                                            <option value="1" <?php selected( $mailit_type, '1' );?>>Local</option>
                                            <option value="2" <?php selected( $mailit_type, '2' );?>>Remote</option>
                                        </select>
                                        <span class="description">If you have Mailit installed on the same WordPress install, select "Local". Otherwise, select "Remote"</span>
                                    </td>
                                </tr>
                            </table>
                            <div class="form-group" id="mailit-local-settings" <?php if($mailit_type == 2) echo 'style="display:none"';?>>
                                <?php
                                $plugin_name = '/mailit';
                                if ( giftmachine_is_plugin_there( $plugin_name ) ) {
                                    if ( giftmachine_is_mailit_plugin_active() ) {
                                        echo '<p class="text-success">Plugin Active</p>';
                                    }
                                    else
                                        echo '<p class="text-warning">Plugin installed, but not active &nbsp;&nbsp;&nbsp; <input type="submit" class="button button-secondary" value="Activate" id="do-activate-mailit"><input type="hidden" id="activate-mailit-plg" name="activate-mailit" value="0"><br/></p>';
                                }
                                else
                                    echo '<p class="text-error">Plugin not installed &nbsp; </p>';
                            ?>
                            </div>

                                    <button type="submit" class="button button-primary" style="margin-right:20px"><i class="fa fa-sign-in"></i> Update changes </button>
                                    <?php if (isset($ar_data['mailit']['cache_expires']) && !empty($ar_data['mailit']['cache_expires'])
                                        && giftmachine_is_plugin_there( $plugin_name ) && giftmachine_is_mailit_plugin_active()
                                    ) { ?>
                                        <button type="button" class="mailit_refresh_lists button button-secondary"><i class="fa fa-refresh"></i> Refresh lists</button>
                                    <?php } ?>

                            <div class="form-group" id="mailit-remote-settings" <?php if($mailit_type == 1) echo 'style="display:none"';?>>

                                <table class="form-table">
                                    <tr valign="top">
                                        <th scope="row">Mailit URL</th>
                                        <td>
                                         <input type="text" class="regular-text" name="giftmachine_mailit_url" placeholder="Enter your Mailt URL" value="<?php echo empty( $ar_data['mailit']['list_url'] ) ? '' : $ar_data['mailit']['list_url']; ?>">
                                            <span class="description">You can find it under Mailit > Lists > Remote Submit URL</span>
                                        </td>
                                    </tr>
                                </table>

                                    <input type="hidden" name="giftmachine_mailit_authorize" value="1">
                                    <button type="submit" class="button button-secondary" ><i class="fa fa-sign-in"></i> Update changes </button>
                            </div>

                        <!-- </fieldset> -->
                        <p><?php
                           // var_dump( giftmachine_get_mailit_mailing_lists()); //nvrC
                          // giftmachine_ar_mailit_subscribe_user(1, 'rrxxrrr@gmail.com', 'xxxxx');
                        // giftmachine_ar_getresponse_move_subscriber('nvrC', 0, 'raulmellado@gmail.com', 0);
                        ?></p>
                </form>

            </div>

            <div id="mymailit-tab" class="tab-inner" style="padding: 20px">

                            <h2><img src="<?php echo GIFTMACHINE_URL;?>/img/icons/icon_mymailit.png" style="vertical-align: top" /> My Mailit   - <a href="https://wpautocontent.com/support/mymailit" target="_blank" style="font-size: 0.9em">Get it here</a></h2>
                            <form action="" method="post" class="form-horizontal" id="mymailit-vp-form">
                                <input type="hidden" name="giftm_autoresponder_update" value="1" />

                            <div class="form-group" id="my-mailit-remote-settings" >

                                <table class="form-table">
                                    <tr valign="top">
                                        <th scope="row">My Mailit List URL</th>
                                        <td>
                                         <input type="text" class="regular-text" name="giftmachine_mymailit_url" placeholder="Enter your Mailt List URL" value="<?php echo empty( $ar_data['mymailit']['list_url'] ) ? '' : $ar_data['mymailit']['list_url']; ?>">
                                            <span class="description">It will be something like https://mymailit.com/members/remotesubmit.php?l=12345</span>
                                        </td>
                                    </tr>
                                </table>

                                    <input type="hidden" name="giftmachine_mymailit_authorize" value="1">
                                    <button type="submit" class="button button-primary" ><i class="fa fa-sign-in"></i> Update changes </button>
                            </div>

                        <!-- </fieldset> -->
                        <p><?php
                           // var_dump( giftmachine_get_mailit_mailing_lists()); //nvrC
                          // giftmachine_ar_mailit_subscribe_user(1, 'rrxxrrr@gmail.com', 'xxxxx');
                        // giftmachine_ar_getresponse_move_subscriber('nvrC', 0, 'raulmellado@gmail.com', 0);
                        ?></p>
                </form>

            </div>

            <div id="aweber-tab" class="tab-inner" style="padding: 20px;display:block">

    <h2><img src="<?php echo GIFTMACHINE_URL;?>/img/icons/icon_aweber.png" style="vertical-align: top" /> Aweber - <a href="https://wpautocontent.com/support/aweber" target="_blank" style="font-size: 0.9em">Get an account</a></h2>

    <?php
    if ( isset($aweber_data['token']) && isset( $aweber_data['token'] ) && $aweber_data['token_secret'] && $aweber_data['token_secret'] ) :?>
        <p class="text-success">You have successfully connected your Aweber account!</p>
        <form action="" method="post">
            <input type="hidden" name="giftm_autoresponder_update" value="1" />
            <input type="hidden" name="giftmachine_aweber_unauthorize" value="1">
            <button type="submit" class="button button-primary" ><i class="fa icon-ban-circle"></i> Disconnect</button>
            <button style="margin-left:20px;" type="button" class="aweber_refresh_lists button button-secondary"><i class="fa fa-refresh"></i> Refresh lists</button>
        </form>
    <?php  else: ?>
        <h4 >Connect To Aweber</h4>
            <p>You need to connect your Aweber account first</p>
            <form action="" method="post">
                <input type="hidden" name="giftm_autoresponder_update" value="1" />
                <input type="hidden" name="giftmachine_aweber_authorize" value="1">
                <button type="submit" class="button button-primary" ><i class="fa fa-sign-in"></i> Connect </button>
            </form>
    <?php endif; ?>

    <br/>
    </div>
            <div id="getresponse-tab" class="tab-inner" style="padding: 20px">
    <h2><img src="<?php echo GIFTMACHINE_URL;?>/img/icons/icon_getresponse.png" style="vertical-align: top" /> Getresponse  - <a href="https://wpautocontent.com/support/getresponse" target="_blank" style="font-size: 0.9em">Get an account</a></h2>

    <form action="" method="post" class="form-horizontal">
        <input type="hidden" name="giftm_autoresponder_update" value="1" />

    <table class="form-table">
        <tr valign="top">
            <th scope="row">API Key</th>
            <td>
             <input type="text" class="form-control regular-text" name="giftmachine_getresponse_api" placeholder="Enter your API key" value="<?php echo empty( $ar_data['getresponse']['apikey'] ) ? '' : $ar_data['getresponse']['apikey']; ?>">
                <span class="description">Get your API key <a target="_blank" href="http://support.getresponse.com/faq/where-i-find-api-key">here</a></span>
            </td>
        </tr>
    </table>

    <input type="hidden" name="giftmachine_getresponse_authorize" value="1">
    <button type="submit" class="button button-primary" ><i class="fa fa-sign-in"></i> Authorize </button>
    <?php if (isset($ar_data['getresponse']['cache_expires']) && !empty($ar_data['getresponse']['cache_expires'])) { ?>
        <button style="margin-left:20px;" type="button" class="getresponse_refresh_lists button button-secondary"><i class="fa fa-refresh"></i> Refresh lists</button>
    <?php } ?>
    </form>

    <br/>
    </div>
    <div id="icontact-tab" class="tab-inner" style="padding: 20px">

    <h2><img src="<?php echo GIFTMACHINE_URL;?>/img/icons/icon_icontact.png" style="vertical-align: top" /> iContact  - <a href="https://wpautocontent.com/support/icontact" target="_blank" style="font-size: 0.9em">Get an account</a></h2>

    <form action="" method="post" class="form-horizontal">
        <input type="hidden" name="giftm_autoresponder_update" value="1" />

        <table class="form-table">
            <tr valign="top">
                <th scope="row">App Id</th>
                <td>
                 <input type="text" class="regular-text form-control" name="giftmachine_icontact_app_id" placeholder="Enter your APP Id" value="<?php echo empty( $ar_data['icontact']['app_id'] ) ? '' : $ar_data['icontact']['app_id']; ?>">
                </td>
            </tr>

            <tr valign="top">
                <th scope="row">Api Username</th>
                <td>
                 <input type="text" class="regular-text form-control" name="giftmachine_icontact_user" placeholder="Enter your Api Username" value="<?php echo empty( $ar_data['icontact']['user'] ) ? '' : $ar_data['icontact']['user']; ?>">
                </td>
            </tr>

            <tr valign="top">
                <th scope="row">Api Password</th>
                <td>
                 <input type="password" class="regular-text form-control" name="giftmachine_icontact_pass" placeholder="Enter your Api Password" value="<?php echo empty( $ar_data['icontact']['pass'] ) ? '' : $ar_data['icontact']['pass']; ?>">
                    <span class="description">Get your API details <a target="_blank" href="http://developer.icontact.com/documentation/register-your-app/">here</a></span>
                </td>
            </tr>

        </table>

        <input type="hidden" name="giftmachine_icontact_authorize" value="1">
        <button type="submit" class="button button-primary" ><i class="fa fa-sign-in"></i> Authorize </button>
        <?php if (isset($ar_data['icontact']['cache_expires']) && !empty($ar_data['icontact']['cache_expires'])) { ?>
            <button style="margin-left:20px;" type="button" class="icontact_refresh_lists button button-secondary"><i class="fa fa-refresh"></i> Refresh lists</button>
        <?php } ?>
    </form>

    <br/>
    </div>
    <div id="mailchimp-tab" class="tab-inner" style="padding: 20px">
    <h2><img src="<?php echo GIFTMACHINE_URL;?>/img/icons/icon_mailchimp.png" style="vertical-align: top" /> Mailchimp  - <a href="https://wpautocontent.com/support/mailchimp" target="_blank" style="font-size: 0.9em">Get an account</a></h2>
    <form action="" method="post" class="form-horizontal">
        <input type="hidden" name="giftm_autoresponder_update" value="1" />

        <table class="form-table">
            <tr valign="top">
                <th scope="row">API Key</th>
                <td>
                 <input type="text" class="form-control regular-text" name="giftmachine_mailchimp_api" placeholder="Enter your Api Key" value="<?php echo empty( $ar_data['mailchimp']['apikey'] ) ? '' : $ar_data['mailchimp']['apikey']; ?>">
                 <span class="description">Get your API key <a target="_blank" href="http://kb.mailchimp.com/article/where-can-i-find-my-api-key">here</a></span>
                </td>
            </tr>
       </table>

                <input type="hidden" name="giftmachine_mailchimp_authorize" value="1">
            <button type="submit" class="button button-primary" ><i class="fa fa-sign-in"></i> Authorize </button>
            <?php if (isset($ar_data['mailchimp']['cache_expires']) && !empty($ar_data['mailchimp']['cache_expires'])) { ?>
                <button style="margin-left:20px;" type="button" class="mailchimp_refresh_lists button button-secondary"><i class="fa fa-refresh"></i> Refresh lists</button>
            <?php } ?>

            <p><?php
                 // var_dump( giftmachine_get_mailchimp_mailing_lists());
                  // giftmachine_ar_constcontact_subscribe_user(2, 'raulmellado@gmail.com', 'Raul Mellado');
            // giftmachine_ar_constcontact_move_subscriber(2, 1, 'raulmellado@gmail.com', 0);
            ?></p>
    </form>

    <br/>
    </div>
        <div id="ccontact-tab" class="tab-inner" style="padding: 20px">
        <h2><img src="<?php echo GIFTMACHINE_URL;?>/img/icons/icon_constantcontact.png" style="vertical-align: top" /> Constant Contact  - <a href="https://wpautocontent.com/support/constantcontact" target="_blank" style="font-size: 0.9em">Get an account</a></h2>
        <form action="" method="post" class="form-horizontal">
            <input type="hidden" name="giftm_autoresponder_update" value="1" />
            <table class="form-table">
                <tr valign="top">
                    <th scope="row">API Username</th>
                    <td>
                     <input type="text" class="form-control regular-text" name="giftmachine_ccontact_user" placeholder="Enter your Api Username" value="<?php echo empty( $ar_data['ccontact']['user'] ) ? '' : $ar_data['ccontact']['user']; ?>">
                    </td>
                </tr>

                <tr valign="top">
                    <th scope="row">API Password</th>
                    <td>
                        <input type="password" class="form-control regular-text" name="giftmachine_ccontact_pass" placeholder="Enter your Api Password" value="<?php echo empty( $ar_data['ccontact']['pass'] ) ? '' : $ar_data['ccontact']['pass']; ?>">
                        <span class="description">Get your API details <a target="_blank" href="http://developer.constantcontact.com/">here</a></span>
                    </td>
                </tr>

           </table>

            <input type="hidden" name="giftmachine_ccontact_authorize" value="1">
            <button type="submit" class="button button-primary" ><i class="fa fa-sign-in"></i> Authorize </button>
            <?php if (isset($ar_data['constantcontact']['cache_expires']) && !empty($ar_data['constantcontact']['cache_expires'])) { ?>
                <button style="margin-left:20px;" type="button" class="constantcontact_refresh_lists button button-secondary"><i class="fa fa-refresh"></i> Refresh lists</button>
            <?php } ?>

        </form>
                                <p><?php
                                     // var_dump( giftmachine_get_constantcontact_mailing_lists());
                                      // giftmachine_ar_constcontact_subscribe_user(2, 'raulmellado@gmail.com', 'Raul Mellado');
                                // giftmachine_ar_constcontact_move_subscriber(2, 1, 'raulmellado@gmail.com', 0);
                                ?></p>
    <br/>
    </div>
        <div id="sendreach-tab" class="tab-inner" style="padding: 20px">
            <h2><img src="<?php echo GIFTMACHINE_URL;?>/img/icons/icon_sendreach.png" style="vertical-align: top" /> SendReach  - <a href="https://wpautocontent.com/support/sendreach" target="_blank" style="font-size: 0.9em">Get an account</a></h2>

            <form action="" method="post" class="form-horizontal">
                <input type="hidden" name="giftm_autoresponder_update" value="1" />
                <table class="form-table">
                    <tr valign="top">
                        <th scope="row">User Id</th>
                        <td>
                         <input type="text" class="form-control regular-text" name="giftmachine_sendreach_user_id" placeholder="Enter your User Id" value="<?php echo empty( $ar_data['sendreach']['user'] ) ? '' : $ar_data['sendreach']['user']; ?>">
                        </td>
                    </tr>

                    <tr valign="top">
                        <th scope="row">Api KEY</th>
                        <td>
                         <input type="text" class="form-control regular-text" name="giftmachine_sendreach_apikey" placeholder="Enter your Api Key" value="<?php echo empty( $ar_data['sendreach']['apikey'] ) ? '' : $ar_data['sendreach']['apikey']; ?>">
                        </td>
                    </tr>

                    <tr valign="top">
                        <th scope="row">API Secret</th>
                        <td>
                            <input type="text" class="form-control regular-text" name="giftmachine_sendreach_secret" placeholder="Enter your Api Secret" value="<?php echo empty( $ar_data['sendreach']['apisecret'] ) ? '' : $ar_data['sendreach']['apisecret']; ?>">
                            <span class="description">Get your API details <a target="_blank" href="http://developer.sendreach.com/documentation/register-your-app/">here</a></span>
                        </td>
                    </tr>
                 </table>

                <input type="hidden" name="giftmachine_sendreach_authorize" value="1">
                <button type="submit" class="button button-primary" ><i class="fa fa-sign-in"></i> Authorize </button>
                <?php if (isset($ar_data['sendreach']['cache_expires']) && !empty($ar_data['sendreach']['cache_expires'])) { ?>
                    <button style="margin-left:20px;" type="button" class="sendreach_refresh_lists button button-secondary"><i class="fa fa-refresh"></i> Refresh lists</button>
                <?php } ?>

                <p><?php

                // var_dump( giftmachine_get_sendreach_mailing_lists(1));
                 // giftmachine_ar_sendreach_subscribe_user(14592, 'pepe2@pepito2.com', 'Pepito 2', 'Perez 2');
                // giftmachine_ar_sendreach_move_subscriber();
                ?></p>
            </form>

            <br/>
            </div>
                <div id="activecampaign-tab" class="tab-inner" style="padding: 20px">
                <h2><img src="<?php echo GIFTMACHINE_URL;?>/img/icons/icon_activecampaign.png" style="vertical-align: top" /> Active Campaign  - <a href="https://wpautocontent.com/support/activecampaign" target="_blank" style="font-size: 0.9em">Get an account</a></h2>
                <form action="" method="post" class="form-horizontal">
                    <input type="hidden" name="giftm_autoresponder_update" value="1" />

                    <table class="form-table">
                        <tr valign="top">
                            <th scope="row">URL</th>
                            <td>
                             <input type="text" class="form-control regular-text" name="giftmachine_activecampaign_url" placeholder="Enter your Active Campaign URL" value="<?php echo empty( $ar_data['activecampaign']['url'] ) ? '' : $ar_data['activecampaign']['url']; ?>">
                            </td>
                        </tr>

                        <tr valign="top">
                            <th scope="row">Api KEY</th>
                            <td>
                             <input type="text" class="form-control regular-text" name="giftmachine_activecampaign_apikey" placeholder="Enter your Api Key" value="<?php echo empty( $ar_data['activecampaign']['apikey'] ) ? '' : $ar_data['activecampaign']['apikey']; ?>">
                            </td>
                        </tr>
                     </table>

                    <input type="hidden" name="giftmachine_activecampaign_authorize" value="1">
                    <button type="submit" class="button button-primary" ><i class="fa fa-sign-in"></i> Authorize </button>
                    <?php if (isset($ar_data['activecampaign']['cache_expires']) && !empty($ar_data['activecampaign']['cache_expires'])) { ?>
                        <button style="margin-left:20px;" type="button" class="activecampaign_refresh_lists button button-secondary"><i class="fa fa-refresh"></i> Refresh lists</button>
                    <?php } ?>

                    <p><?php

                     // var_dump( giftmachine_get_activecampaign_mailing_lists(1));
                     // giftmachine_ar_activecampaign_subscribe_user(2, 'pepe3@pepito3.com', 'Pepito 2', 'Perez 2');
                    // giftmachine_ar_sendreach_move_subscriber();
                    ?></p>
                </form>
                <br/>
                </div>
                    <div id="sendlane-tab" class="tab-inner" style="padding: 20px">
                    <h2><img src="<?php echo GIFTMACHINE_URL;?>/img/icons/icon_sendlane.png" style="vertical-align: top" /> Sendlane   - <a href="https://wpautocontent.com/support/sendlane" target="_blank" style="font-size: 0.9em">Get an account</a></h2>



                                            <form action="" method="post" class="form-horizontal">
                                                <input type="hidden" name="giftm_autoresponder_update" value="1" />

                                                            <table class="form-table">
                                                                <tr valign="top">
                                                                    <th scope="row">Subdomain</th>
                                                                    <td>
                                                                     <input type="text" class="form-control regular-text" name="giftmachine_sendlane_url" placeholder="Enter your User Id" value="<?php echo empty( $ar_data['sendlane']['url'] ) ? '' : $ar_data['sendlane']['url']; ?>">
                                                                     <span class="description">Ex, if your url is http://yoursite.sendlane.com, enter yoursite</span>
                                                                    </td>
                                                                </tr>

                                                                <tr valign="top">
                                                                    <th scope="row">Api KEY</th>
                                                                    <td>
                                                                     <input type="text" class="form-control regular-text" name="giftmachine_sendlane_apikey" placeholder="Enter your Api Key" value="<?php echo empty( $ar_data['sendlane']['apikey'] ) ? '' : $ar_data['sendlane']['apikey']; ?>">
                                                                    </td>
                                                                </tr>

                                                                <tr valign="top">
                                                                    <th scope="row">Hash KEY</th>
                                                                    <td>
                                                                     <input type="text" class="form-control regular-text" name="giftmachine_sendlane_hashkey" placeholder="Enter your Hash Key" value="<?php echo empty( $ar_data['sendlane']['hashkey'] ) ? '' : $ar_data['sendlane']['hashkey']; ?>">
                                                                    </td>
                                                                </tr>
                                                             </table>
                                                                <input type="hidden" name="giftmachine_sendlane_authorize" value="1">

                                                                <button type="submit" class="button button-primary" ><i class="fa fa-sign-in"></i> Authorize </button>
                                                                <?php if (isset($ar_data['sendlane']['cache_expires']) && !empty($ar_data['sendlane']['cache_expires'])) { ?>
                                                                    <button style="margin-left:20px;" type="button" class="sendlane_refresh_lists button button-secondary"><i class="fa fa-refresh"></i> Refresh lists</button>
                                                                <?php } ?>

                                                <p><?php

                                                 // var_dump( giftmachine_get_sendlane_mailing_lists(1));
                                                 // giftmachine_ar_sendlane_subscribe_user(1, 'pepe3@pepito3.com', 'Pepito 2', 'Perez 2');
                                                // giftmachine_ar_sendreach_move_subscriber();
                                                ?></p>
                                            </form>
                                    </div>
                                    </div>
                                    </div>
<?php
}

// selector

function giftmachine_autoresponder_select( $gift_id ) {
    $autoresponders = giftmachine_get_autoresponder_types();
    $current_ar = get_post_meta( $gift_id, '_gift_autoresponder', true );
    $current_list = get_post_meta( $gift_id, '_gift_list', true );
    $lists_sel = false;
    if( !empty( $current_ar ) ) {
        $lists = giftmachine_get_autoresponder_lists( $current_ar );

        if ( $lists ) {
            foreach ($lists as $list) {
                $lists_sel[] = array( 'value' => $list['id'], 'label' => $list['name']);
            }
        }
    }

?>
<p>Select the Autoresponder and List to store the leads for this gift.</p>
<label for="gm-autoresponder" class="labelw">Autoresponder</label>
<select name="gm-autoresponder" id="gm-autoresponder" class="labelw selectw giftmachine_autoresponder">
    <?php
        foreach( $autoresponders as $ar ) {
            echo '<option value="'.$ar[ 'value'] .'" '.selected( $ar[ 'value'], $current_ar, false ).'>'.$ar[ 'label' ] .'</option>';
        }
    ?>
</select>
<br/>
<div id="giftmachine_list_row" <?php if( empty( $current_ar ) ) echo 'style="display:none"';?> >
<label for="gm-list" class="labelw">List</label>
<select name="gm-list" id="gm-list" class="labelw selectw giftmachine_list">
    <?php
        if( !empty( $lists_sel ) ) {
            foreach( $lists_sel as $list ) {
                echo '<option value="'.$list[ 'value'] .'" '.selected( $list[ 'value'], $current_list, false ).'>'.$list[ 'label' ] .'</option>';
            }
        }
    ?>
</select>
</div>
<br/>
<p><small>This is optional, all leads are always stored inside WordPress.</small></p>
<?php
}
?>