<?php

function giftmachine_get_plugin_settings() {
    return get_option( 'giftmachine_settings' );
}

function giftmachine_save_plugin_settings( $settings ) {
    return update_option( 'giftmachine_settings', $settings );
}

function giftmachine_get_settings( $path = array() ) {
    $settings = giftmachine_get_plugin_settings();
    if( empty( $path ) )
        return array();
    $val = $settings;
    foreach( $path as $field ) {
        $val = isset( $val[ $field ] ) ? $val[ $field ] : false;
    }
    return $val;
}

function giftmachine_append_pro( $txt = '', $echo = false ) {
	return $txt . ( giftmachine_is_pro() ? ' Pro' : '' );
}

function giftmachine_is_plugin_there($plugin_dir) {
    $plugins = get_plugins($plugin_dir);
    if ($plugins) return true;
    return false;
}

function giftmachine_show_single_gift( $gift_id, $jacker_id = 0 ) {
    // var_dump($gift_id);
    $gift_id = intval( $gift_id );
    if( empty( $gift_id ) )
        return;
    $cookie_name = 'giftMachine_'.$gift_id;
    if ( /*isset( $_COOKIE[$cookie_name] ) ||*/ isset( $_GET[ 'do_preview' ] ) ) {
        unset($_COOKIE[$cookie_name]); 
        setcookie($cookie_name, null, -1, '/'); 
    }
    $jacker_id = intval( $jacker_id );
    $metas = get_post_custom( $gift_id );
    $icon = GIFTMACHINE_URL.'/images/'.$metas['gift_image_option'][0];
    $fields = explode(",", get_post_meta($gift_id, 'gift_popup_fields', true));
    $btnBgColor = get_post_meta($gift_id, 'gift_popup_button_bg', true);
    $btnTxtColor = get_post_meta($gift_id, 'gift_popup_button_txt', true);
    $btn_txt = get_post_meta($gift_id, 'gift_popup_button', true);
    if( empty( $btn_txt ) )
        $btn_txt = 'Click here';
    if( empty( $btnBgColor ) )
        $btnBgColor = '#666666';
    if( empty( $btnTxtColor ) )
        $btnTxtColor = '#ffffff';
    $str = '';
    $str = '<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/animate.css/4.1.1/animate.min.css" />
        <div id="myModal1" class="gmmodal">
            <div class="gmmodal-content">
                <div class="gmmodal-header" style="background: '.$metas['gift_popup_title_bg'][0].'">
                    <span class="gmclose">&times;</span>
                    <h2>'.$metas['gift_popup_title'][0].'</h2>
                </div>
                <div class="gmmodal-body">
                    <p>'.$metas['gift_popup_content'][0].'</p>
                    <div class="gift_form">
                        <input type="hidden" name="pid" id="pid" value="'.$post->ID.'" />
                        <input type="hidden" name="gid" id="gid" value="'.$gift_id.'" />
                        <table class="form-table"  id="gift-table">
                            <tbody>';
                    if (in_array("name", $fields)) {
                        $str .='   <tr>
                                    <th scope="row"><label>Name</label></th><td>
                                        <input type="text" name="gift_full_name" class="regular-text gm-input" id="gift_full_name" />
                                    </td>
                                </tr>';
                    }
                    if (in_array("email", $fields)) {
                        $str .='   <tr>
                                    <th scope="row"><label>Email</label></th><td>
                                        <input type="text" name="gift_email" class="regular-text gm-input" id="gift_email" />
                                    </td>
                                </tr>';
                    }
                    if (in_array("phone", $fields)) {
                        $str .='   <tr>
                                    <th scope="row"><label>Phone</label></th><td>
                                        <input type="text" name="gift_phone" class="regular-text gm-input" id="gift_phone" />
                                    </td>
                                </tr>';
                    }
                $str .= '</tbody>
                        </table>
                        <div class="text-center"><a class="btngm" id="giftSubmitInfo" href="javascript: void(0);" style="background: '.$btnBgColor.';color: '.$btnTxtColor.'">'.$btn_txt.'</a></div>
                        <div class="clearbb"> </div>
                    </div>
                </div>
                <div class="clearbb"> </div>
            </div>
        </div>
        <input type="hidden" name="gm_jacker_id" id="gm_jacker_id" value="'.$jacker_id.'" />
        <div id="giftIcon"><img class="'.$metas['gift_image_animation'][0].'" src="'.$icon.'" style="width: 100%;" /></div>
    ';
    $str .= '<script>document.addEventListener("DOMContentLoaded", function(event) { showGift('.$gift_id.', "'.$metas['gift_popup_url'][0].'", '.$metas['gift_popup_sec'][0].');});</script>';
    return $str;
}

add_filter( 'plugin_action_links_' . GIFTMACHINE_PLUGIN_NAME.'/'.GIFTMACHINE_PLUGIN_NAME.'.php', 'giftmachine_add_plugin_action_links' );

function giftmachine_add_plugin_action_links( $links ) {
    $giftmachine_options = array(
            'Support' => '<a target="_blank" href="https://kreateplugins.com/help/giftmachine/">Support</a>'
    );

    if( !giftmachine_is_pro() ) {
        $giftmachine_options = array_merge( $giftmachine_options,
            array(
                            'Upgrade to Pro' => '<a target="_blank" href="https://kudosinteractive.clickfunnels.com/oto1-pro1608585489658" style="font-weight:bold;color:red">Upgrade to Gift Machine Pro!</a>'
                )
            );
    }
    else if( !giftmachine_is_jacker() ) {
        $giftmachine_options = array_merge( $giftmachine_options,
            array(
                    'Jacker' => '<a target="_blank" href="https://kudosinteractive.clickfunnels.com/oto1-pro1613984452297" style="color:red;font-weight:bold">Get Gift Machine Jacker Addon</a>'
                )
            );
    }



    return array_merge(
        $links,
        $giftmachine_options
    );
}

function giftmachine_is_whitelabel() {
    return false;
}

function giftmachine_is_pro() {
	// return true;
	return false;
}

?>