<?php

function giftmachine_is_jacker() {
    return function_exists( 'giftmachine_jacker_check_main_plugin' );
}

function giftmachine_screen_jacker() {
        if (! current_user_can ( 'manage_options' ))
            wp_die ( 'You don\'t have access to this page.' );
        if (! user_can_access_admin_page ())
            wp_die ( __ ( 'You do not have sufficient permissions to access this page', 'wp-advanced-pdf' ) );

        if( isset( $_POST['giftmachine_do_reset_stats'] ) && ( $_POST['giftmachine_do_reset_stats'] == 1 ) ) {
            giftmachine_reset_stats();
        }
        // $timeframe = isset( $_GET['tm'] ) ? $_GET['tm'] : false;
        //require (PTPDF_PATH . '/pdf_options_new.php');
    ?>
        <div class="wrap">
            <h1>WP Gift Machine Links</h1>
            <br/>
            <?php
                if( isset( $_GET['lid'] ) ) {
                    giftmachine_new_link( intval ( $_GET['lid'] ) );
                }
                else {
                    giftmachine_link_table();
                }
            ?>
        </div>
        <?php
}


      function giftmachine_link_table() {
        $links = giftmachine_get_links();
        $str_ret = '<br/><a class="button button-primary" href="'.admin_url( 'edit.php?post_type=gifts-pro&page=gmjacker&lid=0' ).'"><i class="fas fa-plus"></i> Add New Link</a><br/><br/>';
        if( $links ) {
            $i = 1;
            $str_ret .= '<table class="widefat"><thead><tr><th scope="col" style="width:25px">#</th><th scope="col">Name</th><th scope="col">URL</th><th scope="col" style="width:55px">Conversions</th><th></th></thead><tbody>';
            foreach( $links as $link ) {
                // $impressions = giftmachine_get_link_impressions( $link->id );
                // $conversions = giftmachine_get_link_conversions( $link->id );
                // $impressions = $conversions = 0;
              $conversions = intval( $link->conversions );
                $str_ret .= '<tr><th>'.$i++.'</th><th scope="row">'.$link->name.'</th><td><input type="text" value="'.site_url( $link->wp_url ).'" id="site-url-'.$link->id.'" style="min-width: 380px" /><button class="copy-jacker button button-primary" data-clipboard-target="#site-url-'.$link->id.'"><i class="fas fa-copy"></i> Copy URL</button></td><td>'.$conversions.'</td><td><a class="button button-secondary" href="'.admin_url( 'edit.php?post_type=gifts-pro&page=gmjacker&lid='.$link->id ).'"><i class="fas fa-edit"></i> Edit</a> <a class="button button-secondary" target="_blank" href="'.site_url( $link->wp_url ).'?do_preview=true"><i class="fas fa-eye"></i> Preview</a> </td>';
            }
            $str_ret .= '</tbody></table>';
        }

        echo $str_ret;
      }

      function giftmachine_new_link( $link_id = 0 ) {
        if( $link_id ) {
            $link = giftmachine_get_link( $link_id );
            $hidden_field = 'giftmachine_update_link';
            echo '<h3>Edit Link</h3>';
        }
        else {
            $link = new stdclass();
            $link->id = 0;
            $link->gift_id = 0;
            $link->name = '';
            $link->url = '';
            $link->wp_url = '';
            // $link->jacklinks = 0;
            $link->link = '';
            $link->page_title = '';
            $link->page_description = '';
            $link->page_image = '';
            $hidden_field = 'giftmachine_create_link';
            echo '<h3>Add Link</h3>';
        }

        ?>
            <form method="POST">
                <table class="form-table">
                    <tr valign="top">
                        <th scope="row">Name</th>
                        <td>
                            <input type="text" class="regular-text" name="giftmachine_link_name" placeholder="Give your link a name" value="<?php echo $link->name; ?>">
                            <span class="description">The link name (won't be displayed anywhere)</span>
                        </td>
                    </tr>

                    <tr valign="top">
                        <th scope="row">Page URL</th>
                        <td>
                            <input type="text" class="regular-text" name="giftmachine_link_url" placeholder="Page URL" value="<?php echo $link->url; ?>" id="giftmachine_link_url">
                            <span class="description">The link URL (ex: https://google.com) </span>
                            <p><small>Note: You can jack links of sites that allow iframes and it may not always work with all the sites on the internet</small></p>
                        </td>
                    </tr>

                    <tr valign="top">
                        <th scope="row">Address</th>
                        <td>
                            <?php echo site_url();?>/<input type="text" class="regular-text" name="giftmachine_link_wp_url" placeholder="Page URL" value="<?php echo $link->wp_url; ?>">
                            <span class="description">The URL inside your site</span>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row">Gift</th>
                        <td>
                            <select name="giftmachine_gift_id">
                                <?php
                                    $gifts = get_posts( array( 'post_type' => 'gifts-pro' ) );
                                    foreach( $gifts as $gift ) {
                                        $post_id = $gift->ID;
                                        echo '<option value="'.$post_id.'" '.selected( $post_id, $link->gift_id, false ).'>'.get_the_title( $post_id ).'</option>';
                                    }
                                ?>
                            </select>
                            <span class="description">The Gift to Display</span>
                        </td>
                    </tr>


<!--                    <tr valign="top">
                        <th scope="row">Capture all page links</th>
                        <td>
                            <input type="checkbox" name="giftmachine_jack_links" id="giftmachine_jack_links" value="1" <?php checked( $link->jacklinks );?>>
                            <span class="description">If checked, all page links will open your URL of choice</span>
                        </td>
                    </tr>

                    <tr valign="top" <?php if( !$link->jacklinks ) echo 'style="display:none"';?> id="giftmachine-link-el">
                        <th scope="row">Redirect URL</th>
                        <td>
                            <input type="text" class="regular-text" name="giftmachine_link" placeholder="Redirect URL" value="<?php echo $link->link; ?>">
                            <span class="description">The link where all page links will redirect</span>
                        </td>
                    </tr>-->
                </table>
                <h4>Social Settings</h4>
                <table class="form-table">
                    <tr valign="top">
                        <th scope="row">Page Title</th>
                        <td>
                            <input type="text" class="regular-text" id="giftmachine_page_title" name="giftmachine_page_title" placeholder="The Page Title" value="<?php echo $link->page_title; ?>">
                            <span class="description">The og page title (for social sharing)</span>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row">Page Description</th>
                        <td>
                            <textarea class="regular-text" id="giftmachine_page_description" name="giftmachine_page_description" placeholder="Page Description"><?php echo $link->page_description; ?></textarea>
                            <span class="description">The og page description (for social sharing)</span>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row">Featured Image</th>
                        <td class="file-upload-parent">
                            <input class="form-control file-upload-url" type="text" size="36" id="giftmachine_page_image" name="giftmachine_page_image" value="<?php echo $link->page_image; ?>" placeholder="Select file..." />
                            <span class="input-group-btn">
                                <button class="button button-secondary giftmachine_img_upload" type="button"><span class="fa fa-upload"></span> Select Image</button>
                            </span>
                            <p class="help-block">
                                <img src="<?php echo $link->page_image; ?>" alt="" class="file-upload-img" style="max-width:300px;height:auto">
                            </p>
                        </td>
                    </tr>
                    <tr valign="top" <?php if( !giftmachine_is_pro() ) { echo 'style="display:none"'; } ?>>
                        <th scope="row">Extra Scripts</th>
                        <td>
                            <textarea class="large-text" style="height: 180px;width:580px" rows="10" name="giftmachine_extra_html" placeholder="Extra Scripts"><?php echo $link->extra_html; ?></textarea>
                            <span class="description">Any extra scripts to be included (facebook pixel, etc)</span>
                        </td>
                    </tr>

                </table>
                <button type="submit" class="button button-primary" ><i class="fas fa-save"></i> Save</button>
                <a href="<?php echo admin_url( 'edit.php?post_type=gifts-pro&page=gmjacker' );?>" class="button button-secondary" ><i class="fas fa-times"></i> Cancel</a>
                <input type="hidden" name="<?php echo $hidden_field;?>" value="1">
                <input type="hidden" name="giftmachine_link_id" value="<?php echo $link_id;?>">
            </form>
        <?php
      }

      add_action( 'init', 'giftmachine_check_link_update' );

      function giftmachine_check_link_update() {
        if( isset( $_POST['giftmachine_create_link'] ) ) {
            $link_name = $_POST['giftmachine_link_name'];
            $link_url = $_POST['giftmachine_link_url'];
            $link_wp_url = $_POST['giftmachine_link_wp_url'];
            $link_gift_id = intval( $_POST['giftmachine_gift_id'] );
            $page_title = $_POST['giftmachine_page_title'];
            $page_description = $_POST['giftmachine_page_description'];
            $page_image = $_POST['giftmachine_page_image'];
            $extra_html = $_POST['giftmachine_extra_html'];
            /*$jack_links = ( isset( $_POST['giftmachine_jack_links'] ) && $_POST['giftmachine_jack_links'] );
            $jack_url = $_POST['giftmachine_link'];*/

            $link_id = giftmachine_add_link( $link_name, $link_url, $link_wp_url,/* $jack_links, $jack_url*/$page_title, $page_description, $page_image, $extra_html, $link_gift_id );
            header( "Location: ".admin_url( 'edit.php?post_type=gifts-pro&page=gmjacker&lid='.$link_id ) );
            exit();
        }
        else if( isset( $_POST['giftmachine_update_link'] ) ) {
            $link_id = intval( $_POST['giftmachine_link_id'] );
            $link_name = $_POST['giftmachine_link_name'];
            $link_url = trim( $_POST['giftmachine_link_url'] );
            $link_wp_url = $_POST['giftmachine_link_wp_url'];
            $link_gift_id = intval( $_POST['giftmachine_gift_id'] );
            /*$jack_links = ( isset( $_POST['giftmachine_jack_links'] ) && $_POST['giftmachine_jack_links'] );
            $jack_url = $_POST['giftmachine_link'];*/
            $page_title = $_POST['giftmachine_page_title'];
            $page_description = $_POST['giftmachine_page_description'];
            $page_image = $_POST['giftmachine_page_image'];
            $extra_html = $_POST['giftmachine_extra_html'];
            giftmachine_update_link( $link_id, $link_name, $link_url, $link_wp_url,/* $jack_links, $jack_url*/$page_title, $page_description, $page_image, $extra_html, $link_gift_id );
            header( "Location: ".admin_url( 'edit.php?post_type=gifts-pro&page=gmjacker&lid='.$link_id ) );
            exit();
        }
      }


      add_action( 'init', 'giftmachine_check_database' );
      function giftmachine_check_database() {
        $db = get_option( 'gifmtachine_db', false );
        if( empty( $db ) ) {
            require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
            global $wpdb;
            $table_name = $wpdb->prefix . "wpgm_links";
            $sql = "CREATE TABLE IF NOT EXISTS $table_name (
              id mediumint(9) NOT NULL AUTO_INCREMENT,
              name VARCHAR(255) DEFAULT '' NOT NULL,
              url VARCHAR(255) DEFAULT '' NOT NULL,
              wp_url VARCHAR(255) DEFAULT '' NOT NULL,
              extra_html TEXT DEFAULT '' NOT NULL,
              link VARCHAR(500) DEFAULT '' NOT NULL,
              jacklinks VARCHAR(1) DEFAULT '0' NOT NULL,
              page_title VARCHAR(2048) DEFAULT '' NOT NULL,
              page_description VARCHAR(2048) DEFAULT '' NOT NULL,
              page_image VARCHAR(2048) DEFAULT '' NOT NULL,
              gift_id int(11) NOT NULL DEFAULT '0',
              conversions int(11) NOT NULL DEFAULT '0',
              PRIMARY KEY (id)
            );";
            dbDelta( $sql );
            update_option( 'gifmtachine_db', 2 );
        }
        else if( $db == 1 ) {
          require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
          global $wpdb;
          $table_name = $wpdb->prefix . "wpgm_links";
          $sql = "ALTER TABLE $table_name ADD
            conversions int(11) NOT NULL DEFAULT '0';
          );";
          dbDelta( $sql );
          update_option( 'gifmtachine_db', 2 );
        }
    }


    // DB


    function giftmachine_get_links( $advanced = false ) {
      global $wpdb;
      $table_name = $wpdb->prefix . "wpgm_links";
      // $table_name2 = $wpdb->prefix . "wpxl_";
      if( $advanced )
        return $wpdb->get_results( "SELECT * FROM $table_name" );
      else
        return $wpdb->get_results( "SELECT * FROM $table_name" );

    }

      function giftmachine_get_link( $link_id ) {
        global $wpdb;
    $table_name = $wpdb->prefix . "wpgm_links";
        return $wpdb->get_row( "SELECT * FROM $table_name WHERE id = ".intval( $link_id ) );
      }

      function giftmachine_add_link( $link_name = '', $link_url= '', $link_wp_url = '',/* $jack_links = 0, $jack_url = ''*/ $page_title = '', $page_description = '', $page_image = '', $extra_html = '', $gift_id = 0 ) {
        global $wpdb;
        // if( $jack_links )
        //   $jack_links = 1;
        // else
        //   $jack_links = 0;
      $table_name = $wpdb->prefix . "wpgm_links";
        $wpdb->query("INSERT INTO $table_name (name, url, wp_url, page_title, page_description, page_image, extra_html, gift_id ) VALUES ( '$link_name', '$link_url', '$link_wp_url', '$page_title', '$page_description', '$page_image', '$extra_html', $gift_id )" );
        return $wpdb->insert_id;
      }

        function giftmachine_update_link( $link_id, $link_name = '', $link_url= '', $link_wp_url = '',/* $jack_links = 0, $jack_url = ''*/ $page_title = '', $page_description = '', $page_image = '', $extra_html = '', $gift_id = 0 ) {
          global $wpdb;
          // if( $jack_links )
          //   $jack_links = 1;
          // else
          //   $jack_links = 0;
          $table_name = $wpdb->prefix . "wpgm_links";
          // die("UPDATE $table_name SET
          //   name = '$link_name',
          //   url = '$link_url',
          //   wp_url = '$link_wp_url',
          //   page_title = '$page_title',
          //   page_description = '$page_description',
          //   page_image = '$page_image',
          //   extra_html = '$extra_html'
          //   WHERE id = ".intval( $link_id ) );
          $sql = "UPDATE $table_name SET
                      name = '$link_name',
                      url = '$link_url',
                      wp_url = '$link_wp_url',
                      page_title = '$page_title',
                      page_description = '$page_description',
                      page_image = '$page_image',
                      extra_html = '$extra_html',
                      gift_id = $gift_id
                      WHERE id = ".intval( $link_id );
                      // die( $sql );
          $wpdb->query( $sql );
        }


        function giftmachine_add_conversion( $link_id = 0 ) {
          if( empty( $link_id ) )
            return;
          global $wpdb;
        $table_name = $wpdb->prefix . "wpgm_links";
          $wpdb->query("UPDATE $table_name SET conversions = conversions + 1 WHERE id = ".intval( $link_id ) );
        }

        function giftmachine_add_impression( $link_id = 0 ) {
          global $wpdb;
        $table_name = $wpdb->prefix . "wpxl_impressions";
          $wpdb->query("INSERT INTO $table_name (link_id, created_at ) VALUES ( $link_id, NOW() )" );
          return $wpdb->insert_id;
        }

        function giftmachine_get_link_impressions( $link_id  = 0 ) {
          global $wpdb;
          return $wpdb->get_var( 'SELECT count(id) FROM '.$wpdb->prefix.'wpxl_impressions WHERE link_id = '.intval( $link_id ) );
        }


        /* FRONTEND */

        add_action('init', 'giftmachine_check_if_redirect', -1); 

        function giftmachine_check_if_redirect() {

            $userrequest = str_ireplace(get_option('home'),'',giftmachine_get_address());
            $userrequest = ltrim(giftmachine_rstrstr($userrequest, '?'),'/');

            // $userrequest = rtrim($userrequest, '/');
            $userrequest = str_replace( site_url(), '', $userrequest );
            $userrequest = rtrim($userrequest, '/');
            $userrequest = ltrim($userrequest, '/');
/*
            $plugin_options = giftmachine_get_plugin_options();
            $visual_options = $plugin_options['cta'];
            $text_color = $visual_options['text_color'];
            $button_color = $visual_options['button_color'];
            $button_text = $visual_options['cta_text'];
            $intro_text = $visual_options['intro_text'];
            $email_text = $visual_options['email_text'];
            $name_text = $visual_options['name_text'];
            $do_redirect = $visual_options['do_redirect'];
            $redirect_link = $visual_options['redirect_link'];
            $thankyou_text = empty( $visual_options['thankyou'] ) ? 'Thank you' : $visual_options['thankyou'];
            $askfor = $visual_options['askfor'];
            $position = $visual_options['display_button'];
            switch( $position ) {
                case 1:
                    $style_pos = 'bottom:0;left:0';
                    break;
                case 2:
                    $style_pos = 'top:0;right:0';
                    break;
                case 3:
                    $style_pos = 'top:0;left:0';
                    break;
                default:
                    $style_pos = 'bottom:0;right:0';
                    break;
            }

            $popup_style = intval( $visual_options['popup_style'] );
            $auto_show = $visual_options['auto_show'];
            $auto_show_secs = ( $visual_options['auto_show_secs'] ) * 1000;
            $auto_show_js = '';
            if( $auto_show ) {
                $auto_show_js = 'jQuery( document ).ready(function(  ) { setTimeout(function(){ do_display_modal(); }, '.$auto_show_secs.'); });';
            }

            $exit_popup_js = '';
            $exit_popup = $visual_options['exit_popup'];
            if( $exit_popup ) {
                $exit_popup_js = 'var wpxlc_exit = 0;
                window.addEventListener("beforeunload", function (e) {
                    if( wpxlc_exit )
                        return false;
                  var confirmationMessage = "Enter your e-mail to download this page as PDF.";
                  do_display_modal();
                  wpxlc_exit = 1;;
                  (e || window.event).returnValue = confirmationMessage;
                  return confirmationMessage;
                });';
            }
            $bar_html = '';
            if( $visual_options['enable_bar'] ) {
                $bar_html = '<div id="wpxl-bar" style="'.$style_pos.';color:'.$visual_options['bar_tcolor'].';background-color:'.$visual_options['bar_color'].'">'.$visual_options['bar_content'].'</div>';
            }
*/


            // $css_styles = jj_get_css_styles();
            // $redirect = ( ( $do_redirect && !empty( $redirect_link ) ) ? trim( $redirect_link ) : '' );
            $links = giftmachine_get_links();
            // var_dump($links);
            // var_dump($userrequest);

            if ($links) {
                foreach ($links as $link) {
                    if ($link->wp_url == $userrequest) {
                        if ( strpos($userrequest, '/wp-login') !== 0 && strpos($userrequest, '/wp-admin') !== 0 ) {
                            // var_dump($link);
                            // die();
                            $redirect_url = $link->url;
                            $title = isset( $link->page_title ) && !empty( $link->page_title ) ? $link->page_title : '';
                            $description = isset( $link->page_description ) && !empty( $link->page_description ) ? $link->page_description : '';
                            $image = isset( $link->page_image ) && !empty( $link->page_image ) ? $link->page_image : '';
                            $extra_html = isset( $link->extra_html ) && !empty( $link->extra_html ) ? $link->extra_html : '';
                            $js_redirect_url = '';

                            if ( 1 ){
                                $str = '<!DOCTYPE html>
                                <html>
                                  <head>
                                    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
                                    <!-- Place this data between the <head> tags of your website -->
                                    <title>'.$title.'</title>
                                    <meta name="description" content="'.$description.'" />
                                    <meta name="keywords" content="">

                                    <!-- Schema.org markup for Google+ -->
                                    <meta itemprop="name" content="'.$title.'">
                                    <meta itemprop="description" content="'.$description.'">
                                    <meta itemprop="image" content="'.$image.'">

                                    <!-- Twitter Card data -->
                                    <meta name="twitter:card" content="summary_large_image">
                                    <meta name="twitter:title" content="'.$title.'">
                                    <meta name="twitter:description" content="'.$description.'">
                                    <!-- Twitter summary card with large image must be at least 280x150px -->
                                    <meta name="twitter:image:src" content="'.$image.'">

                                    <!-- Open Graph data -->
                                    <meta property="og:title" content="'.$title.'" />
                                    <meta property="og:type" content="article" />
                                    <meta property="og:url" content="'.site_url( $link->wp_url ).'" />
                                    <meta property="og:image" content="'.$image.'" />
                                    <meta property="og:description" content="'.$description.'" />
                                    <meta property="og:site_name" content="'.get_bloginfo( 'name' ).'" />
                                    <meta property="article:section" content="Article Section" /> 
                                  <link rel="stylesheet" type="text/css" href="'.get_stylesheet_directory_uri().'/style.css" />
                                  <link rel="stylesheet" type="text/css" href="'.GIFTMACHINE_URL.'/style/front.css" />
                                    <style>
                                    * { margin: 0; padding: 0; }
                                    html, body { width: 100%; height: 100%; }
                                    #wpxfiframe {
                                      width: 100%;
                                      height: 100%;
                                      border: 0;
                                      margin: 0;
                                      padding: 0;
                                        line-height: 0; 
                                        position: absolute;
                                        overflow: hidden;
                                        display: block;
                                    }
                                    </style>
                                  </head>
                                  <body>
                                  <iframe src="'.$redirect_url.'" id="wpxfiframe" width="100%" height="100%" frameborder="0"></iframe>
                                  '.giftmachine_show_single_gift( $link->gift_id, $link->id ).'
                                  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
                                  <script src="'.GIFTMACHINE_URL.'/scripts/front.js" /></script>
                                  <script>
                                  const vars = new Object();
                                  vars.ajax_url = "'.admin_url( 'admin-ajax.php' ).'";
                                  </script>
                                  </body>
                                </html>';
                                  if( $str ) {
                                      echo $str;
                                      // wpcryptomj_add_impression( $link->id );
                                  }
                                  // die();
                                  exit();
                            }
                        }
                    }
                }
            }
        }

        function giftmachine_get_address() {
            return giftmachine_get_protocol().'://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
        }

        function giftmachine_get_protocol() {
            $protocol = 'http';
            if ( isset( $_SERVER["HTTPS"] ) && strtolower( $_SERVER["HTTPS"] ) == "on" ) {
                $protocol = 'https';
            }
            return $protocol;
        }

        function giftmachine_rstrstr($haystack,$needle)
            {
                $substring = substr($haystack, 0,strpos($haystack, $needle));
                if (empty($substring)) return $haystack;
                return $substring;
            }

    function giftmachine_get_og_tags() {
      $url = isset( $_POST[ 'url' ] ) ? trim( $_POST[ 'url' ] ) : '';
      if( empty( $url ) ) {
        echo json_encode( array( 'error' => 1 ) );
        exit();
      }
      if (filter_var($url, FILTER_VALIDATE_URL) === FALSE) {
          echo json_encode( array( 'error' => 2 ) );
          exit();
      }
      require_once GIFTMACHINE_DIR.'/lib/metas.php';
      $metas = new GMURLMeta( $url );
      $ret = $metas->parse();
      // var_dump($ret);
      // var_dump($metas);
      $title = isset( $ret->title ) ? trim( $ret->title ) : '';
      $description = isset( $ret->description ) ? trim( $ret->description ) : '';
      $image = isset( $ret->image ) ? trim( $ret->image ) : '';
      $ret = array( 'error' => 0, 'title' => $title, 'description' => $description, 'image' => $image );
      echo json_encode( $ret );
      exit();
    }
?>