<?php

function giftmachine_is_saas() {
  // return true;
    return function_exists( 'giftmachine_saas_check_main_plugin' );
}

function giftmachine_screen_saas() {
        if (! current_user_can ( 'manage_options' ))
            wp_die ( 'You don\'t have access to this page.' );
        if (! user_can_access_admin_page ())
            wp_die ( __ ( 'You do not have sufficient permissions to access this page', 'wp-advanced-pdf' ) );

        if( isset( $_POST['giftmachine_do_reset_stats'] ) && ( $_POST['giftmachine_do_reset_stats'] == 1 ) ) {
            giftmachine_reset_stats();
        }
        // $timeframe = isset( $_GET['tm'] ) ? $_GET['tm'] : false;
        //require (PTPDF_PATH . '/pdf_options_new.php');
    ?>
        <div class="wrap">
            <h1>WP Gift Machine External Sites</h1>
            <br/>
            <?php
                giftmachine_saas_table();
            ?>
            <br/>
            <p>To use Gift Machine on any site, just click on "Get Code" for that gift, and paste that code on your website.</p>
        </div>
        <div id="myModal22" class="gmmodal">
          <div class="gmmodal-content">
            <div class="gmmodal-header" style="background: green">
              <span class="gmclose">&times;</span>
              <h2 id="gift-names">Get Code</h2>
            </div>
            <div class="gmmodal-body">
              <h3 id="gift-namess" style="text-align:center"></h3>
              <textarea name="" id="gift-code" cols="30" rows="5" style="margin: 10px 0"></textarea>
              <p style="margin-top:0;padding-top:0">Paste this code on any website where you would like the gift to show; before the closing body tag</p>
              <button type="button" id="copy-code-btn" data-clipboard-target="#gift-code" class="button button-primary"><i class="fas fa-copy"></i> Copy Code </button>
              <button type="button" class="button button-secondary gmclose2" style="float:right"><i class="fas fa-times"></i> Close </button>
            </div>
          </div>
        </div>
        <script>
          var saas_gift_url = "<?php echo GIFTMACHINE_URL;?>/script/giftmachine.php";
        </script>
        <?php
}


      function giftmachine_saas_table() {
        $links = giftmachine_get_saas();
        if( $links ) {
            $i = 1;
            $str_ret .= '<table class="widefat"><thead><tr><th scope="col" style="width:25px">#</th><th scope="col">Name</th><th></th></thead><tbody>';
            foreach( $links as $link ) {
                // $impressions = giftmachine_get_link_impressions( $link->id );
                // $conversions = giftmachine_get_link_conversions( $link->id );
                $impressions = $conversions = 0;
                $str_ret .= '<tr data-gift-id="'.$link->ID.'"><th>'.$i++.'</th><th scope="row" class="gift-name">'.get_the_title( $link->ID ).'</th><td><button type="button" class="btn-show-saas button button-primary"><i class="fas fa-code"></i> Get Code</button></td>';
            }
            $str_ret .= '</tbody></table>';
        }

        echo $str_ret;
      }

      function giftmachine_get_saas() {
        $gifts = get_posts( array( 'post_type' => 'gifts-pro' ) );
        return $gifts;
      }

      function giftmachine_new_saas( $link_id = 0 ) {
        if( $link_id ) {
            $link = giftmachine_get_saas( $link_id );
            $hidden_field = 'giftmachine_update_link';
            echo '<h3>Edit Link</h3>';
        }
        else {
            $link = new stdclass();
            $link->id = 0;
            $link->gift_id = 0;
            $link->name = '';
            $link->url = '';
            $link->wp_url = '';
            // $link->jacklinks = 0;
            $link->link = '';
            $link->page_title = '';
            $link->page_description = '';
            $link->page_image = '';
            $hidden_field = 'giftmachine_create_link';
            echo '<h3>Add Link</h3>';
        }

        ?>
            <form method="POST">
                <table class="form-table">
                    <tr valign="top">
                        <th scope="row">Name</th>
                        <td>
                            <input type="text" class="regular-text" name="giftmachine_link_name" placeholder="Give your link a name" value="<?php echo $link->name; ?>">
                            <span class="description">The link name (won't be displayed anywhere)</span>
                        </td>
                    </tr>

                    <tr valign="top">
                        <th scope="row">Page URL</th>
                        <td>
                            <input type="text" class="regular-text" name="giftmachine_link_url" placeholder="Page URL" value="<?php echo $link->url; ?>">
                            <span class="description">The link URL (ex: http://google.com) </span>
                        </td>
                    </tr>

                    <tr valign="top">
                        <th scope="row">Address</th>
                        <td>
                            <?php echo site_url();?>/<input type="text" class="regular-text" name="giftmachine_link_wp_url" placeholder="Page URL" value="<?php echo $link->wp_url; ?>">
                            <span class="description">The URL inside your site</span>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row">Gift</th>
                        <td>
                            <select name="giftmachine_gift_id">
                                <?php
                                    $gifts = get_posts( array( 'post_type' => 'gifts-pro' ) );
                                    foreach( $gifts as $gift ) {
                                        $post_id = $gift->ID;
                                        echo '<option value="'.$post_id.'" '.selected( $post_id, $link->gift_id, false ).'>'.get_the_title( $post_id ).'</option>';
                                    }
                                ?>
                            </select>
                            <span class="description">The Gift to Display</span>
                        </td>
                    </tr>


<!--                    <tr valign="top">
                        <th scope="row">Capture all page links</th>
                        <td>
                            <input type="checkbox" name="giftmachine_jack_links" id="giftmachine_jack_links" value="1" <?php checked( $link->jacklinks );?>>
                            <span class="description">If checked, all page links will open your URL of choice</span>
                        </td>
                    </tr>

                    <tr valign="top" <?php if( !$link->jacklinks ) echo 'style="display:none"';?> id="giftmachine-link-el">
                        <th scope="row">Redirect URL</th>
                        <td>
                            <input type="text" class="regular-text" name="giftmachine_link" placeholder="Redirect URL" value="<?php echo $link->link; ?>">
                            <span class="description">The link where all page links will redirect</span>
                        </td>
                    </tr>-->
                </table>
                <h4>Social Settings</h4>
                <table class="form-table">
                    <tr valign="top">
                        <th scope="row">Page Title</th>
                        <td>
                            <input type="text" class="regular-text" name="giftmachine_page_title" placeholder="The Page Title" value="<?php echo $link->page_title; ?>">
                            <span class="description">The og page title (for social sharing)</span>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row">Page Description</th>
                        <td>
                            <textarea class="regular-text" name="giftmachine_page_description" placeholder="Page Description"><?php echo $link->page_description; ?></textarea>
                            <span class="description">The og page description (for social sharing)</span>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row">Featured Image</th>
                        <td class="file-upload-parent">
                            <input class="form-control file-upload-url" type="text" size="36" name="giftmachine_page_image" value="<?php echo $link->page_image; ?>" placeholder="Select file..." />
                            <span class="input-group-btn">
                                <button class="button button-secondary giftmachine_img_upload" type="button"><span class="fa fa-upload"></span> Select Image</button>
                            </span>
                            <p class="help-block">
                                <img src="<?php echo $link->page_image; ?>" alt="" class="file-upload-img" style="max-width:300px;height:auto">
                            </p>
                        </td>
                    </tr>
                    <tr valign="top" <?php if( !giftmachine_is_pro() ) { echo 'style="display:none"'; } ?>>
                        <th scope="row">Extra Scripts</th>
                        <td>
                            <textarea class="large-text" style="height: 180px;width:580px" rows="10" name="giftmachine_extra_html" placeholder="Extra Scripts"><?php echo $link->extra_html; ?></textarea>
                            <span class="description">Any extra scripts to be included (facebook pixel, etc)</span>
                        </td>
                    </tr>

                </table>
                <button type="submit" class="button button-primary" ><i class="fas fa-save"></i> Save</button>
                <a href="<?php echo admin_url( 'edit.php?post_type=gifts-pro&page=gmsaas' );?>" class="button button-secondary" ><i class="fas fa-times"></i> Cancel</a>
                <input type="hidden" name="<?php echo $hidden_field;?>" value="1">
                <input type="hidden" name="giftmachine_link_id" value="<?php echo $link_id;?>">
            </form>
        <?php
      }

      add_action( 'init', 'giftmachine_check_saas_update' );

      function giftmachine_check_saas_update() {
        if( isset( $_POST['giftmachine_create_saas'] ) ) {
            $link_name = $_POST['giftmachine_link_name'];
            $link_url = $_POST['giftmachine_link_url'];
            $link_wp_url = $_POST['giftmachine_link_wp_url'];
            $link_gift_id = intval( $_POST['giftmachine_gift_id'] );
            $page_title = $_POST['giftmachine_page_title'];
            $page_description = $_POST['giftmachine_page_description'];
            $page_image = $_POST['giftmachine_page_image'];
            $extra_html = $_POST['giftmachine_extra_html'];
            /*$jack_links = ( isset( $_POST['giftmachine_jack_links'] ) && $_POST['giftmachine_jack_links'] );
            $jack_url = $_POST['giftmachine_link'];*/

            $link_id = giftmachine_add_link( $link_name, $link_url, $link_wp_url,/* $jack_links, $jack_url*/$page_title, $page_description, $page_image, $extra_html, $link_gift_id );
            header( "Location: ".admin_url( 'edit.php?post_type=gifts-pro&page=gmsaas&lid='.$link_id ) );
            exit();
        }
        else if( isset( $_POST['giftmachine_update_saas'] ) ) {
            $link_id = intval( $_POST['giftmachine_link_id'] );
            $link_name = $_POST['giftmachine_link_name'];
            $link_url = trim( $_POST['giftmachine_link_url'] );
            $link_wp_url = $_POST['giftmachine_link_wp_url'];
            $link_gift_id = intval( $_POST['giftmachine_gift_id'] );
            /*$jack_links = ( isset( $_POST['giftmachine_jack_links'] ) && $_POST['giftmachine_jack_links'] );
            $jack_url = $_POST['giftmachine_link'];*/
            $page_title = $_POST['giftmachine_page_title'];
            $page_description = $_POST['giftmachine_page_description'];
            $page_image = $_POST['giftmachine_page_image'];
            $extra_html = $_POST['giftmachine_extra_html'];
            giftmachine_update_link( $link_id, $link_name, $link_url, $link_wp_url,/* $jack_links, $jack_url*/$page_title, $page_description, $page_image, $extra_html, $link_gift_id );
            header( "Location: ".admin_url( 'edit.php?post_type=gifts-pro&page=gmsaas&lid='.$link_id ) );
            exit();
        }
      }

/*
      add_action( 'init', 'giftmachine_check_database' );
      function giftmachine_check_database() {
        $db = get_option( 'gifmtachine_db', false );
        if( empty( $db ) ) {
            require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
            global $wpdb;
            $table_name = $wpdb->prefix . "wpgm_links";
            $sql = "CREATE TABLE IF NOT EXISTS $table_name (
              id mediumint(9) NOT NULL AUTO_INCREMENT,
              name VARCHAR(255) DEFAULT '' NOT NULL,
              url VARCHAR(255) DEFAULT '' NOT NULL,
              wp_url VARCHAR(255) DEFAULT '' NOT NULL,
              extra_html TEXT DEFAULT '' NOT NULL,
              link VARCHAR(500) DEFAULT '' NOT NULL,
              jacklinks VARCHAR(1) DEFAULT '0' NOT NULL,
              page_title VARCHAR(2048) DEFAULT '' NOT NULL,
              page_description VARCHAR(2048) DEFAULT '' NOT NULL,
              page_image VARCHAR(2048) DEFAULT '' NOT NULL,
              PRIMARY KEY (id)
            );";
            dbDelta( $sql );
            update_option( 'gifmtachine_db', 1 );
        }
    }*/

/*
    // DB


    function giftmachine_get_links( $advanced = false ) {
      global $wpdb;
      $table_name = $wpdb->prefix . "wpgm_links";
      // $table_name2 = $wpdb->prefix . "wpxl_";
      if( $advanced )
        return $wpdb->get_results( "SELECT * FROM $table_name" );
      else
        return $wpdb->get_results( "SELECT * FROM $table_name" );

    }

      function giftmachine_get_link( $link_id ) {
        global $wpdb;
    $table_name = $wpdb->prefix . "wpgm_links";
        return $wpdb->get_row( "SELECT * FROM $table_name WHERE id = ".intval( $link_id ) );
      }

      function giftmachine_add_link( $link_name = '', $link_url= '', $link_wp_url = '', $page_title = '', $page_description = '', $page_image = '', $extra_html = '', $gift_id = 0 ) {
        global $wpdb;
        // if( $jack_links )
        //   $jack_links = 1;
        // else
        //   $jack_links = 0;
      $table_name = $wpdb->prefix . "wpgm_links";
        $wpdb->query("INSERT INTO $table_name (name, url, wp_url, page_title, page_description, page_image, extra_html ) VALUES ( '$link_name', '$link_url', '$link_wp_url', '$page_title', '$page_description', '$page_image', '$extra_html', $gift_id )" );
        return $wpdb->insert_id;
      }

        function giftmachine_update_link( $link_id, $link_name = '', $link_url= '', $link_wp_url = '', $page_title = '', $page_description = '', $page_image = '', $extra_html = '', $gift_id = 0 ) {
          global $wpdb;
          // if( $jack_links )
          //   $jack_links = 1;
          // else
          //   $jack_links = 0;
          $table_name = $wpdb->prefix . "wpgm_links";
          // die("UPDATE $table_name SET
          //   name = '$link_name',
          //   url = '$link_url',
          //   wp_url = '$link_wp_url',
          //   page_title = '$page_title',
          //   page_description = '$page_description',
          //   page_image = '$page_image',
          //   extra_html = '$extra_html'
          //   WHERE id = ".intval( $link_id ) );
          $sql = "UPDATE $table_name SET
                      name = '$link_name',
                      url = '$link_url',
                      wp_url = '$link_wp_url',
                      page_title = '$page_title',
                      page_description = '$page_description',
                      page_image = '$page_image',
                      extra_html = '$extra_html',
                      gift_id = $gift_id
                      WHERE id = ".intval( $link_id );
                      // die( $sql );
          $wpdb->query( $sql );
        }


        function giftmachine_add_impression( $link_id = 0 ) {
          global $wpdb;
        $table_name = $wpdb->prefix . "wpxl_impressions";
          $wpdb->query("INSERT INTO $table_name (link_id, created_at ) VALUES ( $link_id, NOW() )" );
          return $wpdb->insert_id;
        }

        function giftmachine_get_link_impressions( $link_id  = 0 ) {
          global $wpdb;
          return $wpdb->get_var( 'SELECT count(id) FROM '.$wpdb->prefix.'wpxl_impressions WHERE link_id = '.intval( $link_id ) );
        }
*/

?>