<?php
function giftmachine_page_handler_stats() {
	if (! current_user_can ( 'manage_options' ))
		wp_die ( 'You don\'t have access to this page.' );
	if (! user_can_access_admin_page ())
		wp_die ( __ ( 'You do not have sufficient permissions to access this page', 'wp-advanced-pdf' ) );

	$timeframe = isset( $_GET['tm'] ) ? $_GET['tm'] : false;
	//require (PTPDF_PATH . '/pdf_options_new.php');
?>
	<div class="wrap">
			<h1>WP Gift Machine <?php echo giftmachine_append_pro();?> Stats</h1>
			<br/>

			<!-- start autoresponders -->
			<div id="content-giftmachine-settings" class="col-lg-12">
				<div class="row">
					<?php giftmachine_stats_table( $timeframe ); ?>
				</div>
			</div>
			<br/><br/>
			<form method="POST" id="giftmachine-reset-stats-f">
				<input type="hidden" name="giftmachine_do_reset_stats" value="1">
			</form>
	</div>

<?php }

function giftmachine_stats_table( $timeframe = false ) {
	$giftmachine_stats = giftmachine_get_stats( false, $timeframe );
	// $giftmachine_stats = get_option( 'giftmachine_stats' );
	if( !$giftmachine_stats )
		$giftmachine_stats = array( 0, 0, 0 );
?>
<style>
.widefat .hueco {
	background-color: transparent;
}

.widefat .big_one {
	font-size: 3em;
	text-align: center;
	padding: 10px;
}

div.diffgm {
	float:left;
	margin-right: 30px;
	min-width: 120px;
	text-align: center;
}

div.diffgm th {
	text-align: center;
}

#gift-tleads thead th,
#gift-tleads tbody td {
	text-align: center;
}
</style>
	<div class="diffgm">
		<table class="widefat" style="width:100%;float:left">
			<tr><th scope="col">Total Leads</th></tr>
			<tr>
				<td class="big_one"><?php echo $giftmachine_stats[0];?></td>
			</tr>
		</table>
	</div>
	<div class="diffgm">
	<table class="widefat" style="width:100%;float:left">
		<tr><th scope="col">Today</th></tr>
		<tr>
			<td class="big_one"><?php echo $giftmachine_stats[1];?></td>
		</tr>
	</table>
	</div>
	<div class="diffgm">
	<table class="widefat" style="width:100%;float:left">
		<tr><th scope="col">Last 7 Days</th></tr>
		<tr>
			<td class="big_one"><?php echo $giftmachine_stats[2];?></td>
		</tr>
	</table>
	</div>
	<div class="diffgm">
	<table class="widefat" style="width:100%;float:left">
		<tr><th scope="col">Last 30 Days</th></tr>
		<tr>
			<td class="big_one"><?php echo $giftmachine_stats[3];?></td>
		</tr>
	</table>
	</div>


	<div class="clear"></div>
	<br/><br/>
	<h2>By Gift</h2>

	<table class="widefat" id="gift-tleads"><thead>
		<tr><th scope="col">Gift</th><th scope="col">Total</th><th scope="col">Today</th><th scope="col">Last 7 Days</th><th scope="col">Last 30 Days</th></tr>
	</thead><tbody>
	<?php
		$page = isset( $_GET['pagenum'] ) ? intval( $_GET['pagenum'] ) : 1;
		$per_page = 50;
		  	/*global $wpdb;
	        $table_name = $wpdb->prefix . "wpxl_leads";
		  	$total_query = "SELECT COUNT(id) FROM $table_name";

		  	$total = $wpdb->get_var( $total_query );*/

		$str_ret = '';
		$args = array(
		    'post_type' => 'gifts-pro',
		    'post_status' => 'any',
		    'posts_per_page' => -1
		);

		$my_query = new WP_Query($args);
		$total = $my_query->found_posts;

		$args = array(
		    'post_type' => 'gifts-pro',
		    'post_status' => 'publish',
		    'orderby'          => 'ID',
		    'posts_per_page'   => $per_page,
	    	'offset'           => ($page-1)*$per_page,
		);

		$posts = get_posts($args);
		if( $posts ) {
			foreach( $posts as $post ) {
				$stats = giftmachine_get_stats( $post->ID, $timeframe );

				$str_ret .= '<tr><th style="font-weight:bold">'.get_the_title( $post->ID) .'</th><td>'.$stats[0].'</td><td>'.$stats[1].'</td><td>'.$stats[2].'</td><td>'.$stats[3].'</td></tr>';
			}
			echo $str_ret;
		}
	?>
	</tbody></table>
<?php

	$num_of_pages = ceil( $total / $per_page );

	$page_links = paginate_links( array(
		'base' => add_query_arg( /*'pagenum', '%#%'*/ array(
			    'pagenum' => '%#%'
			)
		),
		'format' => '',
		'end_size' => 4,
		'mid_size' => 3,
		'prev_text' => __( '«', 'text-domain' ),
		'next_text' => __( '»', 'text-domain' ),
		'total' => $num_of_pages,
		'current' => $page
	) );
	if ( $page_links ) {
	echo '<div class="tablenav"><div class="tablenav-pages" style="margin: 1em 0;">' . $page_links . '</div></div>';
	}
}


function giftmachine_get_stats( $gift_id = false, $timeframe = false ) {
	global $wpdb;
	$filter = '';
	$cr = 0;
	if( $gift_id )
		$filter .= ' AND gid = '.$gift_id;

	$filter_today .= ' AND time like "%'.date("Y-m-d").'%"';
	$filter_last7 .= ' AND DATE(time) > (NOW() - INTERVAL 7 DAY)';
	$filter_last30 .= ' AND DATE(time) > (NOW() - INTERVAL 30 DAY)';

	$sql = 'SELECT count(id) FROM '.$wpdb->prefix.'gift_machine_pro WHERE 1 = 1 '.$filter;
	$total = $wpdb->get_var( $sql );

	$sql = 'SELECT count(id) FROM '.$wpdb->prefix.'gift_machine_pro WHERE 1 = 1 '.$filter.$filter_today;
	$today = $wpdb->get_var( $sql );

	$sql = 'SELECT count(id) FROM '.$wpdb->prefix.'gift_machine_pro WHERE 1 = 1 '.$filter.$filter_last7;
	$last7 = $wpdb->get_var( $sql );

	$sql = 'SELECT count(id) FROM '.$wpdb->prefix.'gift_machine_pro WHERE 1 = 1 '.$filter.$filter_last30;
	$last30 = $wpdb->get_var( $sql );

	return array( intval( $total ), intval( $today ), intval( $last7 ), intval( $last30 ) );
}
?>